#!/usr/bin/env bash

echo Content-type: text/html
echo ''

case `basename ${PATH_INFO:-byname}` in
  bytime) timeopt='-t'; sizeopt=cat ;;
  bysize) timeopt=''; sizeopt='sort -t# -n -k 2' ;;
  *) timeopt=''; sizeopt=cat ;;
esac

dir=${SCRIPT_NAME%/*}
parent="${SCRIPT_FILENAME%/*}/.."
parenthref="${SCRIPT_NAME%/*}/.."

echo "<H1>Index of $dir</H1>"
if [ -r $parent ]
then
  echo "<a href=\"$parenthref\">Parent Directory</a>"
  echo "<hr />"
fi
echo "<table>"
echo "<tr><th><a href=\"$SCRIPT_NAME/../index.cgi/byname\">Name</th><th>&nbsp;&nbsp;<a href=\"$SCRIPT_NAME/../index.cgi/bytime\">Last modified &nbsp;&nbsp;</th><th><a href=\"$SCRIPT_NAME/../index.cgi/bysize\">Bytes</th></tr>"
ls -l $timeopt | awk 'NR>1 {print "<tr>" "<td><a href=\"'$SCRIPT_NAME/../'"$9"\">" $9 "</td>" "<td>&nbsp;&nbsp;" $6, $7, $8 "&nbsp;&nbsp;</td>" "<td>#"$5 "</td></tr>"}' | $sizeopt
echo "</table>"
if [ -f README ]
then
  echo "<hr />"
  echo "<pre>"
  cat README
  echo "</pre>"
fi
