\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{nsfcurpend}[2007/06/01 RIG imitiation NSF Current and Pending Support]

% \LoadClassWithOptions{letter}%
% Can use the above line as a replacement for the following three if
% get LaTeX2e version postdating 1995/12/01, but the letterhead stuff
% in this file is designed only to work for letterpaper or legalpaper.
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{letter}}%
\ProcessOptions\relax
\LoadClass[]{letter}%

\def\emptycontents{%
\def\curcontents{\phantom{\x}}%
\def\pendcontents{\phantom{\x}}%
\def\plannedcontents{\phantom{\x}}%
\def\transfercontents{\phantom{\x}}%
\def\titlecontents{}%
\def\sourcecontents{}%
\def\amountcontents{}%
\def\periodcontents{\phantom{00/00/00 - 00/00/00}}%
\def\locationcontents{}%
\def\calcontents{\phantom{{\bf 0.00}}}%
\def\acadcontents{\phantom{{\bf 0.00}}}%
\def\sumrcontents{\phantom{{\bf 0.00}}}%
}

\emptycontents

\def\investigator#1{\def\investigatorcontents{{\bf #1}}}

\newcommand\xbox[1]{\hbox{\rlap{$\sqcap$}\rlap{#1}$\sqcup$}}
\newcommand\x{\hspace*{.01in}{\footnotesize\sf X}}

\def\cur#1{\def\curcontents{{\bf #1}}}
\def\pend#1{\def\pendcontents{{\bf #1}}}
\def\planned#1{\def\plannedcontents{{\bf #1}}}
\def\transfer#1{\def\transfercontents{{\bf #1}}}
\def\cptitle#1{\def\titlecontents{{\bf #1}}}
\def\source#1{\def\sourcecontents{{\bf #1}}}
\def\amount#1{\def\amountcontents{{\bf #1}}}
\def\cpperiod#1{\def\periodcontents{{\bf #1}}}
\def\cploc#1{\def\locationcontents{{\bf #1}}}
\def\cal#1{\def\calcontents{{\bf #1}}}
\def\acad#1{\def\acadcontents{{\bf #1}}}
\def\sumr#1{\def\sumrcontents{{\bf #1}}}

\def\support{\framebox{\parbox{6.4in}{Support: \quad\xbox{\curcontents}Current\quad
\xbox{\pendcontents}Pending\quad
\xbox{\plannedcontents}Submission Planned in Near Future\quad
\xbox{\transfercontents}*Tranfer of Support \\
\begin{tabular}{@{}l@{}c@{}p{4.4in}@{}}%
Project/Proposal Title: & \rule[-9ex]{0in}{9ex} & \titlecontents \\
Source of Support: && \sourcecontents \\
Total Award Amount: &\$& \hfill\amountcontents\ Total Award Period Covered:\ \ \periodcontents \\
Location of Project: && \locationcontents
\end{tabular}%
\\ Person-Months Per Year Committed to the Project.\qquad Cal: \calcontents \quad Acad: \acadcontents \quad Sumr: \sumrcontents
}}}
