   {print}
 /^%dashline|^%dotline|^%line/ {
   illegal = ""
   begx = $2 ;
   begy = $3 ;
   endx = $4 ;
   endy = $5 ;
   hsep = endx - begx ;
   vsep = endy - begy ;
   sep = sqrt(hsep*hsep+vsep*vsep) ;
   hsign = vsign = 0 ;
   if (hsep != 0) hsign = hsep/sqrt(hsep*hsep) ; # = sign(hsep)
   if (vsep != 0) vsign = vsep/sqrt(vsep*vsep) ; # = sign(vsep)
   horvsep = hsep*hsign ;
   if (hsep == 0) horvsep = vsep*vsign ;
   if (horvsep == 0)
      {illegal = illegal ": slope" ; print "%illegal slope", 0} ;
   }
 /^%dashline|^%line/ {
   delx = 0 ;
   dely = vsign ;
   if (hsep != 0) {
      delx = 1 ;
      dely = 0 ;
      if (vsep != 0) {
         slope = vsep/hsep ;
         abslope = sqrt(slope*slope) ; # = |slope|
         labslope = log(abslope) ; # = log(|slope|)
         mabslope = exp(sqrt(labslope*labslope)) ; # = e^(|log(|slope|)|)
         for (i=5; i>=1; i--) if (i*mabslope == int(i*mabslope)) delx = i ;
         dely = delx*mabslope ;
         if (dely != int(dely))
            {illegal = illegal ": slope" ; print "%illegal slope", slope} ;
         if (abslope < 1) {temp=delx; delx=dely; dely=temp} ;
         }
      delx = delx*hsign ;
      dely = dely*vsign ;
      }
   }
 /^%dashline|^%dotline/ {
   inperiod = $6 ;
   fracperiods = sep/inperiod ;
   }
 /^%dotline/ {
   periods = int(fracperiods+.999999) ;
   items = periods+1 ;
   xperiod = hsep/periods ;
   yperiod = vsep/periods ;
   item = "{\makebox(0,0){\\tenrm .}}" ;
   }
 /^%dashline/ {
   items = int(fracperiods+.499999)+1 ;
   periods = items - .5 ;
   xperiod = hsep/periods ;
   yperiod = vsep/periods
   dashlen = xperiod/2 ;
   if (hsep == 0) dashlen = yperiod/2 ;
   dashlen = sqrt(dashlen*dashlen) ; # = |dashlen|
   item = "{\line(" delx "," dely "){" dashlen "}}"
   }
 /^%dashline|^%dotline|^%line/ {if (illegal != "") printf "%%"}
 /^%dashline|^%dotline/ {
   print "\multiput(" begx "," begy ")(" xperiod "," yperiod "){" items "}" item}
 /^%line/ {
   print "\put(" begx "," begy "){\line(" delx "," dely "){" horvsep "}}"
   }
